SystemOrganization addCategory: #'Seaside-Cache-NG'!

WAError subclass: #WAMaximumNumberOfSessionsExceededError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WAMaximumNumberOfSessionsExceededError commentStamp: 'pmm 9/8/2013 17:59' prior: 0!
http://ora-00018.ora-code.com/!

WAObject subclass: #WACacheKeyEntryNG
	instanceVariableNames: 'key keyHash value next byAccessListEntry byCreationListEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WACacheKeyEntryNG class methodsFor: 'instance creation' stamp: 'pmm 9/10/2013 09:08'!
key: aKey value: anObject
	^ self basicNew
		initializeWithKey: aKey value: anObject;
		yourself! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:33'!
byAccessListEntry
	^ byAccessListEntry! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/10/2013 09:21'!
byAccessListEntry: aCacheListEntry
	byAccessListEntry := aCacheListEntry! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:33'!
byCreationListEntry
	^ byCreationListEntry! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/10/2013 09:22'!
byCreationListEntry: aCacheListEntry
	byCreationListEntry := aCacheListEntry! !

!WACacheKeyEntryNG methodsFor: 'initialization' stamp: 'pmm 9/10/2013 09:07'!
initializeWithKey: aKey value: anObject
	self initialize.
	key := aKey.
	keyHash := aKey hash.
	value := anObject! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:28'!
key
	^ key! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 11:51'!
keyHash
	^ keyHash! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 11:07'!
next
	^ next! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 14:53'!
next: aCacheKeyEntry
	next := aCacheKeyEntry! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:28'!
value
	^ value! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 15:22'!
value: anObject
	value := anObject! !

WAObject subclass: #WACacheListEntryNG
	instanceVariableNames: 'previous next time cacheEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WACacheListEntryNG class methodsFor: 'instance creation' stamp: 'pmm 9/10/2013 09:16'!
entry: aCacheEntry
	^ self basicNew
		initializeWithEntry: aCacheEntry;
		yourself! !

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:27'!
cacheEntry
	^ cacheEntry! !

!WACacheListEntryNG methodsFor: 'operations' stamp: 'pmm 9/9/2013 12:06'!
expunge
	next isNil ifFalse: [
		next previous: previous ].
	previous isNil ifFalse: [
		previous next: next ].
	next := nil.
	previous := nil! !

!WACacheListEntryNG methodsFor: 'operations' stamp: 'pmm 9/9/2013 12:08'!
initializeTime
	time := Time totalSeconds! !

!WACacheListEntryNG methodsFor: 'initialization' stamp: 'pmm 9/10/2013 09:15'!
initializeWithEntry: aCacheEntry
	self initialize.
	cacheEntry := aCacheEntry.
	self initializeTime! !

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 09:28'!
next
	^ next! !

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 09:28'!
next: aCacheListEntry
	next := aCacheListEntry! !

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 09:28'!
previous
	^ previous! !

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 09:28'!
previous: aCacheListEntry
	previous := aCacheListEntry! !

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:17'!
time
	^ time! !

WAObject subclass: #WACacheNG
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WACacheNG commentStamp: 'pmm 9/9/2013 09:13' prior: 0!
WACacheNG is the abstract base class for session and continuation stores in Seaside. The default implementation is WAHashCacheNG.!

!WACacheNG methodsFor: 'accessing' stamp: 'pmm 8/26/2012 12:17'!
at: aKey ifAbsent: aBlock
	self subclassResponsibility! !

!WACacheNG methodsFor: 'putting' stamp: 'pmm 8/26/2012 12:15'!
at: aKey put: anObject
	self subclassResponsibility! !

!WACacheNG methodsFor: 'public' stamp: 'pmm 9/8/2013 17:50'!
clear
	self subclassResponsibility! !

!WACacheNG methodsFor: 'accessing' stamp: 'pmm 8/26/2012 12:19'!
keyAtValue: anObject ifAbsent: aBlock
	self subclassResponsibility! !

!WACacheNG methodsFor: 'enumerating' stamp: 'pmm 8/26/2012 12:04'!
keysAndValuesDo: aTwoArgumentBlock
	self subclassResponsibility! !

!WACacheNG methodsFor: 'copying' stamp: 'pmm 9/9/2013 09:12'!
postCopy
	self subclassResponsibility! !

!WACacheNG methodsFor: 'removing' stamp: 'pmm 8/26/2012 12:16'!
remove: anObject
	self subclassResponsibility! !

!WACacheNG methodsFor: 'putting' stamp: 'pmm 8/26/2012 12:49'!
store: anObject
	"Store anObject in the cache, generating a new random key. Return the key."
	self subclassResponsibility! !

WACacheNG subclass: #WAHashCacheNG
	instanceVariableNames: 'keyTable valueTable size maximumSize maximumRelativeAge maximumAbsoluteAge overflowAction byAccessStart byAccessEnd byCreationStart byCreationEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WAHashCacheNG commentStamp: 'pmm 9/9/2013 12:01' prior: 0!
WAHashCacheNG is a hashtable based implementation of WACacheNG.

The characteristics of WAHashCacheNG are:
- supports both absolute and relative timeouts at the same time https://www.owasp.org/index.php/Session_Management_Cheat_Sheet#Automatic_Session_Expiration
- supports a maximum size with definable overflow action (expire oldest, expire least recently used, signal exception)
- access by key is fast (O(1) average case O(n) worst case)
- access by value is fast (O(1) average case O(n) worst case)
- reaping expired sesssions is proportinal (O(n)) to the number of expired session and independent of the total number of sessions (O(1))
- creating a new session independent of the total number of sessions

Instance Variables:
	keyTable	<Matrix | SequenceableCollection>
	valueTable	<Matrix | SequenceableCollection>
	size	<Color | DateAndTime | Duration | FloatArray | Interval | Number | OBMetaNode | Point | Timespan | TraitComposition | TraitDescription | TraitTransformation | WordArray>
	maximumSize	<ProtoObject | PseudoContext>
	maximumRelativeAge	<CharacterBlock | GRVersion | Magnitude | Point | String | UUID | WAHttpVersion>
	maximumAbsoluteAge	<CharacterBlock | GRVersion | Magnitude | Point | String | UUID | WAHttpVersion>
	overflowAction	<ProtoObject | PseudoContext>
	byAccessRoot	<ProtoObject | PseudoContext>
	byCreationRoot	<ProtoObject | PseudoContext>!

!WAHashCacheNG class methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:16'!
overflowActions
	^ Array
		with: self removeRelativeOldest
		with: self removeAbsoluteOldest
		with: self signalError! !

!WAHashCacheNG class methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:15'!
removeAbsoluteOldest
	^ #removeAbsoluteOldest! !

!WAHashCacheNG class methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:15'!
removeRelativeOldest
	^ #removeRelativeOldest! !

!WAHashCacheNG class methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:01'!
signalError
	^ #signalError! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 15:33'!
addToAccessEnd: aCacheListEntry
	| currentLast |
	currentLast := byAccessEnd.
	currentLast isNil ifFalse: [
		currentLast next: aCacheListEntry.
		aCacheListEntry previous: currentLast ].
	aCacheListEntry initializeTime.
	byAccessEnd := aCacheListEntry! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 15:32'!
addToCreationEnd: aCacheListEntry
	| currentLast |
	currentLast := byCreationEnd.
	currentLast isNil ifFalse: [
		currentLast next: aCacheListEntry.
		aCacheListEntry previous: currentLast ].
	byCreationEnd := aCacheListEntry! !

!WAHashCacheNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 13:36'!
at: aKey ifAbsent: aBlock
	| keyHash index entry |
	self sweepIncrementally.
	keyHash := aKey hash.
	index := keyHash \\ keyTable size.
	entry := self findEntryOrNilWithKey: aKey hash: keyHash index: index.
	^ entry isNil
		ifTrue: [ aBlock value ]
		ifFalse: [ entry key ]! !

!WAHashCacheNG methodsFor: 'putting' stamp: 'pmm 9/10/2013 11:01'!
at: aKey put: anObject
	| index keyHash entry |
	self sweepIncrementally.
	self growCheck.
	keyHash := aKey hash.
	index := keyHash \\ keyTable size.
	entry := self findEntryOrNilWithKey: aKey hash: keyHash index: index.
	entry isNil
		ifTrue: [
			| cacheEntry byAccessEntry byCreationEntry |
			(maximumSize > 0 and: [ size = maximumSize ])
				ifTrue: [ self performOverflowAction ].
			"create entry"
			cacheEntry := WACacheKeyEntryNG key: aKey value: anObject.
			byCreationEntry := WACacheListEntryNG entry: cacheEntry.
			byAccessEntry := WACacheListEntryNG entry: cacheEntry.
			cacheEntry byAccessListEntry: byAccessEntry.
			cacheEntry byCreationListEntry: byCreationEntry.
			self addToAccessEnd: byAccessEntry.
			self addToCreationEnd: byCreationEntry.
			"update value table"
			self mapValue: anObject to: aKey ]
		ifFalse: [
			| byAccessListEntry byCreationListEntry |
			byAccessListEntry := entry byAccessListEntry.
			byCreationListEntry := entry byCreationListEntry.
			"update entry"
			entry value: anObject.
			self expunge: byAccessListEntry.
			self addToAccessEnd: byAccessListEntry.
			self expunge: byCreationListEntry.
			self addToCreationEnd: byCreationListEntry.
			self updateMappingOf: aKey from: entry value to: anObject ]! !

!WAHashCacheNG methodsFor: 'public' stamp: 'pmm 9/9/2013 12:01'!
clear
	size = 0.
	keyTable atAllPut: nil.
	valueTable atAllPut: nil. 
	byAccessStart := nil.
	byAccessEnd := nil.
	byCreationStart := nil.
	byCreationEnd := nil! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 15:14'!
errorKeyNotFound
	self error: 'Key not found'! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 12:03'!
expunge: aListEntry
	"update list start"
	aListEntry == byAccessStart
		ifTrue: [ byAccessStart := aListEntry next ].
	aListEntry == byCreationStart
		ifTrue: [ byCreationStart := aListEntry next ].
	"update list end"
	aListEntry == byAccessEnd
		ifTrue: [ byAccessEnd := aListEntry previous ].
	aListEntry == byCreationEnd
		ifTrue: [ byCreationEnd := aListEntry previous ].
	"fix previous and next pointers"
	aListEntry expunge.! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 15:33'!
findEntryOrNilWithKey: aKey hash: anHashInteger index: anIndexInteger
	| entry |
	entry := keyTable at: anIndexInteger.
	entry isNil whileFalse: [
		(entry keyHash = anHashInteger and: [ entry key = aKey ])
			ifTrue: [
				| byAccessListEntry |
				byAccessListEntry := entry byAccessListEntry.
				self expunge: byAccessListEntry.
				self addToAccessEnd: byAccessListEntry.
				^ entry ]
			ifFalse: [ entry := entry next ] ].
	^ nil! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 14:24'!
growCheck
	size > (keyTable size * self loadFactor) ifTrue: [
		"rehash for fun"
		| newKeyTable newValueTable newTableSize |
		newTableSize := self newTableSize.
		newKeyTable := Array new: newTableSize.
		newValueTable := Array new: newTableSize.
		
		"refash keys"
		keyTable do: [ :each |
			| next current |
			current := each.
			next := current next.
			current isNil whileFalse: [
				| index atTargetIndex |
				index := current keyHash \\ newTableSize.
				atTargetIndex isNil
					ifTrue: [ newKeyTable at: index put: current ]
					ifFalse: [
						atTargetIndex next isNil whileFalse: [
							atTargetIndex := atTargetIndex next ].
						atTargetIndex next: current ].
				current next: nil.
				current := next.
				next := current next ] ].
		
		"rehash values"
		valueTable do: [ :each |
			| next current |
			current := each.
			next := current next.
			current isNil whileFalse: [
				| index atTargetIndex |
				index := current valueHash \\ newValueTable.
				atTargetIndex isNil
					ifTrue: [ newValueTable at: index put: current ]
					ifFalse: [
						atTargetIndex next isNil whileFalse: [
							atTargetIndex := atTargetIndex next ].
						atTargetIndex next: current ].
				current next: nil.
				current := next.
				next := current next ] ].
		keyTable := newKeyTable.
		valueTable := newValueTable ]! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 14:27'!
includesKey: aKey
	self at: aKey ifAbsent: [ ^ false ].
	^ true! !

!WAHashCacheNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 15:29'!
keyAtValue: anObject ifAbsent: aBlock
	| valueHash index entry |
	self sweepIncrementally.
	valueHash := anObject hash.
	index := valueHash \\ valueTable size.
	entry := valueTable at: index.
	entry isNil whileFalse: [
		(entry valueHash = valueHash and: [ entry value = anObject ])
			ifTrue: [ ^ entry value ]
			ifFalse: [ entry := entry next ] ].
	self flag: #todo. "access time"
	^ aBlock value! !

!WAHashCacheNG methodsFor: 'enumerating' stamp: 'pmm 9/9/2013 11:15'!
keysAndValuesDo: aTwoArgumentBlock
	self sweepIncrementally.
	keyTable do: [ :each |
		| cacheEntry |
		cacheEntry := each.
		cacheEntry isNil whileFalse: [
			aTwoArgumentBlock value: cacheEntry key value: cacheEntry value.
			cacheEntry := cacheEntry next ] ]! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 09:17'!
loadFactor
	^ 0.75! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/10/2013 10:12'!
mapValue: anObject to: aKey
	| valueHash index entry previous newEntry |
	valueHash := anObject hash.
	index := valueHash \\ valueTable size.
	newEntry := WACacheValueEntryNG value: anObject key: aKey.
	entry := valueTable at: index.
	previous := nil.
	entry isNil whileFalse: [
		(entry valueHash = valueHash and: [ entry value = anObject ])
			ifTrue: [
				previous isNil
					ifTrue: [ valueTable at: index put: newEntry ]
					ifFalse: [  previous next: newEntry ] ]
			ifFalse: [
				previous := entry.
				entry := entry next ] ]! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 13:44'!
newTableSize
	^ keyTable size * 2! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 12:01'!
performOverflowAction
	overflowAction == self class signalError ifTrue: [
		WAMaximumNumberOfSessionsExceededError signal ].
	overflowAction == self class removeAbsoluteOldest ifTrue: [
		self removeCacheEntry: byCreationStart cacheEntry ].
	overflowAction == self class removeRelativeOldest ifTrue: [
		self removeCacheEntry: byAccessStart cacheEntry ]! !

!WAHashCacheNG methodsFor: 'removing' stamp: 'pmm 9/9/2013 11:14'!
remove: anObject
	| key |
	self sweepIncrementally.
	key := self keyAtValue: anObject ifAbsent: [ ^ anObject ].
	self removeKey: key! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 14:46'!
removeCacheEntry: aCacheEntry
	self removeFromKeyTable: aCacheEntry.
	self removeFromValueTable: aCacheEntry value.
	self expunge: aCacheEntry byAccessListEntry.
	self expunge: aCacheEntry byCreationListEntry.
	
	size := size - 1! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 14:54'!
removeFromKeyTable: aCacheEntry
	| index entry previous |
	index := aCacheEntry keyHash \\ keyTable size.
	entry := keyTable at: index.
	previous := nil.
	"no need for nil check, it has to be here"
	aCacheEntry == entry whileFalse: [
		previous := entry.
		entry := entry next ].
	previous isNil
		ifFalse: [ keyTable at: index put: entry next ]
		ifTrue: [ previous next: entry next ]! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 15:07'!
removeFromValueTable: anObject
	| entry valueHash index previous |
	valueHash := anObject hash.
	index := valueHash \\ valueTable size.
	entry := valueTable at: index.
	previous := nil.
	[	"no need for nil check it has to be there"
		(entry valueHash = valueHash and: [ entry value = anObject ])
			ifTrue: [
				 previous isNil
					ifTrue: [ valueTable at: index put: entry next ]
					ifFalse: [ previous next: entry next ].
				^ self ]
			ifFalse: [
				previous := entry.
				entry := entry next ] ] repeat.! !

!WAHashCacheNG methodsFor: 'removing' stamp: 'pmm 9/9/2013 15:14'!
removeKey: aKey
	| keyHash index entry |
	self sweepIncrementally.
	keyHash := aKey hash.
	index := keyHash \\ keyTable size.
	entry := self findEntryOrNilWithKey: aKey hash: keyHash index: index.
	^ entry isNil
		ifTrue: [ self errorKeyNotFound ]
		ifFalse: [ self removeCacheEntry: entry ]! !

!WAHashCacheNG methodsFor: 'putting' stamp: 'pmm 8/26/2012 12:53'!
store: anObject
	| candidateKey |
	[ 
		candidateKey := WAKeyGenerator current keyOfLength: self keySize.
		self includesKey: candidateKey ] whileTrue.
	self at: candidateKey put: anObject.
	^ candidateKey! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 10:06'!
sweep: aListRoot maximumAge: anNumberOfSeconds now: currentSeconds
	| current |
	current := aListRoot.
	current isNil whileFalse: [
		(current time + anNumberOfSeconds) > currentSeconds
			ifTrue: [
				self removeCacheEntry: current cacheEntry ]
			ifFalse: [
				"the list is ordered so we can stop scanning"
				^ self ] ]! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 12:01'!
sweepIncrementally
	| now |
	now := Time totalSeconds.
	
	"absolute timeout sweep"
	maximumAbsoluteAge > 0 ifTrue: [
		self sweep: byCreationStart maximumAge: maximumAbsoluteAge now: now ].
	
	"relative timeout sweep"
	maximumRelativeAge > 0 ifTrue: [
		self sweep: byAccessStart maximumAge: maximumRelativeAge now: now ]! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/10/2013 11:03'!
updateMappingOf: aKey from: oldValue to: newValue
	self removeFromValueTable: oldValue.
	self mapValue: newValue to: aKey! !

WACacheNG subclass: #WAMutualExclusionCacheNG
	instanceVariableNames: 'mutex cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WAMutualExclusionCacheNG commentStamp: 'pmm 9/9/2013 09:07' prior: 0!
WAMutualExclusionCacheNG is a wrapper around a WACacheNG that wraps all messages in a mutex.

Instance Variables:
	mutex	<WAMutex>
	cache	<WACache>!

!WAMutualExclusionCacheNG class methodsFor: 'instance creation' stamp: 'pmm 8/26/2012 12:08'!
on: aCache
	^ self basicNew initializeOn: aCache; yourself! !

!WAMutualExclusionCacheNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 17:48'!
at: aKey ifAbsent: aBlock
	^ mutex critical: [
		cache at: aKey ifAbsent: aBlock ]	! !

!WAMutualExclusionCacheNG methodsFor: 'putting' stamp: 'pmm 9/8/2013 17:49'!
at: aKey put: anObject
	^ mutex critical: [
		cache at: aKey put: anObject ]	! !

!WAMutualExclusionCacheNG methodsFor: 'public' stamp: 'pmm 9/8/2013 17:49'!
clear
	^ mutex critical: [
		cache clear ]	! !

!WAMutualExclusionCacheNG methodsFor: 'initialization' stamp: 'pmm 9/1/2012 11:07'!
initializeOn: aCache
	self initialize.
	mutex := WAMutex new.
	cache := aCache! !

!WAMutualExclusionCacheNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 17:48'!
keyAtValue: anObject ifAbsent: aBlock
	^ mutex critical: [
		cache keyAtValue: anObject ifAbsent: aBlock ]	! !

!WAMutualExclusionCacheNG methodsFor: 'enumerating' stamp: 'pmm 9/8/2013 17:48'!
keysAndValuesDo: aTwoArgumentBlock
	^ mutex critical: [
		cache keysAndValuesDo: aTwoArgumentBlock ]	! !

!WAMutualExclusionCacheNG methodsFor: 'removing' stamp: 'pmm 9/8/2013 17:50'!
remove: anObject
	^ mutex critical: [
		cache remove: anObject ]	! !

!WAMutualExclusionCacheNG methodsFor: 'putting' stamp: 'pmm 8/26/2012 12:48'!
store: anObject
	^ mutex critical: [
		cache store: anObject ]	! !

WAObject subclass: #WACacheValueEntryNG
	instanceVariableNames: 'value valueHash key next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WACacheValueEntryNG class methodsFor: 'instance creation' stamp: 'pmm 9/10/2013 09:12'!
value: anObject key: aKey
	^ self basicNew
		initializeWithValue: anObject key: aKey
		yourself! !

!WACacheValueEntryNG methodsFor: 'initialization' stamp: 'pmm 9/10/2013 09:12'!
initializeWithValue: anObject key: aKey
	self initialize.
	value := anObject.
	valueHash := anObject hash.
	key := aKey! !

!WACacheValueEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 13:26'!
key
	^ key! !

!WACacheValueEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 13:26'!
next
	^ next! !

!WACacheValueEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 15:08'!
next: aCacheValueEntry
	next := aCacheValueEntry! !

!WACacheValueEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 13:27'!
value
	^ value! !

!WACacheValueEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 13:26'!
valueHash
	^ valueHash! !
